/********************************** (C) COPYRIGHT  *******************************
* File Name          : MCU_communication_interface.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2020/10/12
* Description        : CH32 ͨӿ
*******************************************************************************/
#include "stdio.h"
#include "MCU_communication_interface.h"
#include "delay.h"
#include "sys.h"

void ch395_SPI_init(void)
{
  GPIO_InitTypeDef  GPIO_InitStructure;
  SPI_InitTypeDef  SPI_InitStructure;
	
  RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB | RCC_AHB1Periph_GPIOC, ENABLE);//ʹGPIOAʱ
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI2, ENABLE);//ʹSPI1ʱ
 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_Init(GPIOB, &GPIO_InitStructure);
	
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13|GPIO_Pin_15;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_Init(GPIOB, &GPIO_InitStructure);
	//GPIO_PinAFConfig(GPIOB,GPIO_PinSource12,GPIO_AF_SPI2);
	GPIO_PinAFConfig(GPIOB,GPIO_PinSource13,GPIO_AF_SPI2);
	GPIO_PinAFConfig(GPIOB,GPIO_PinSource15,GPIO_AF_SPI2);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_14;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
  GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
  GPIO_Init(GPIOB, &GPIO_InitStructure);
	GPIO_PinAFConfig(GPIOB,GPIO_PinSource14,GPIO_AF_SPI2);
	
	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;  //SPI˫ģʽ:SPIΪ˫˫ȫ˫
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;		//SPIģʽ:ΪSPI
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;		//SPIݴС:SPIͽ8λ֡ṹ
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;		//ͬʱӵĿ״̬Ϊߵƽ
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;	//ͬʱӵĵڶأ½ݱ
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;		//NSSźӲNSSܽţʹSSIλ:ڲNSSźSSIλ
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_32;		//岨ԤƵֵ:ԤƵֵΪ256
	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;	//ָݴMSBλLSBλʼ:ݴMSBλʼ
	SPI_InitStructure.SPI_CRCPolynomial = 7;	//CRCֵĶʽ
	SPI_Init(SPI2, &SPI_InitStructure);  //SPI_InitStructָĲʼSPIxĴ
 
	SPI_Cmd(SPI2, ENABLE); //ʹSPI
}


void control_gpio_init(void)
{
	GPIO_InitTypeDef  GPIO_InitStructure;

	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE); 

	/* CH395ж PA0*/
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	/* CH395λ PA1*/
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;//
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
}


void ch395_write_cmd( uint8_t mCmd )
{
	ch395_scs_hign;                /* ֹCSԭΪͣȽCSø */
	delay_us(1); 
  ch395_scs_low;                 /* ʼCS */

  ch395_write_data(mCmd);        /* SPI */
	delay_us(10);                   /* Ҫʱ,ʱ1.5uSȷдڲС1.5uS */                   /* Ҫʱ,ʱ1.5uSȷдڲС1.5uS */
}

/**
----------------------------------------  CH395Ӳдȡ -----------------------------------------
---------------------------------------  ֲAPIλ -----------------------------------------
 */
void ch395_write_data(uint8_t mData)
{	
  while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_TXE) == RESET);//ȴ  
	
	SPI_I2S_SendData(SPI2, mData); //ͨSPIxһbyte  
		
  while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_RXNE) == RESET); //ȴһbyte  
 
	SPI_I2S_ReceiveData(SPI2); //ͨSPIxյ	
}

/**
-----------------------------------------  CH395Ӳȡ -----------------------------------------
----------------------------------------  ֲAPIλ -----------------------------------------
 */
uint8_t ch395_read_data( void )
{
	while((SPI2_SR & SPI_I2S_FLAG_TXE)==RESET);	
	SPI2_DR=0xff;
	while((SPI2_SR & SPI_I2S_FLAG_RXNE)==RESET);	
	return (uint8_t)SPI2_DR;
}

void spi_data_write(uint8_t mData)
{
	while ((SPI2_SR & SPI_I2S_FLAG_TXE) == RESET) ;	
	SPI2_DR=mData;
}


